com.trendmicro.ds.appcontrol.rest.api

## Interface ISoftwareInventoryAPI

-     @Produces(value="application/json")
       @Consumes(value="application/json")
       @Path(value="/software-inventory")
      public interface ISoftwareInventoryAPI

  Interface for the SoftwareInventory API.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `CreateInventoryResponse` | `createInventory(java.lang.String sessionID, CreateInventoryRequest request)` Create an inventory of a host.
    `void` | `deleteInventory(java.lang.String sessionID, java.lang.Long inventoryID)` Delete an inventory list.
    `DescribeInventoryResponse` | `describeInventory(java.lang.String sessionID, java.lang.Long inventoryID)` Retrieve inventory list metadata.
    `GetInventoryResponse` | `getInventory(java.lang.String sessionID, java.lang.Long inventoryID, java.lang.Long itemID, java.lang.String itemIDOp, java.lang.Integer maxItems)` Retrieve inventory list details.
    `ListInventoriesResponse` | `listInventories(java.lang.String sessionID, java.lang.Long inventoryID, java.lang.String inventoryIDOp, java.lang.Integer maxItems)` Retrieve the list of all inventory metadata.

- - ### Method Detail

    - #### createInventory

          @POST
          CreateInventoryResponse createInventory(@CookieParam(value="sID")
                                                        java.lang.String sessionID,
                                                        CreateInventoryRequest request)
                                                 throws java.lang.Exception

      Create an inventory of a host.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API.
        `request` - a `CreateInventoryRequest` describing the inventory action to take.
      Returns:
        a `CreateInventoryResponse` carrying the ID of the created inventory list.
      Throws:
        `java.lang.Exception`

    - #### listInventories

          @GET
          ListInventoriesResponse listInventories(@CookieParam(value="sID")
                                                       java.lang.String sessionID,
                                                       @QueryParam(value="inventoryID")
                                                       java.lang.Long inventoryID,
                                                       @QueryParam(value="inventoryIDOp")
                                                       java.lang.String inventoryIDOp,
                                                       @QueryParam(value="maxItems")
                                                       java.lang.Integer maxItems)
                                                throws java.lang.Exception

      Retrieve the list of all inventory metadata.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API.
        `inventoryID` - (optional) used to define the starting point for the query. Combine with `inventoryIDOp` to page through results.
        `inventoryIDOp` - (optional, required if `inventoryID` is specified) Currently supported operations include gt(greater than), ge(greater than or equal to), eq(eqaul to), lt(less than), and le(less than or equal to).
        `maxItems` - (optional) the number of items to retrieve. The maximum value for this parameter is controlled by the "Maximum number of items to retrieve from database" setting on the administrator account, which defaults to 5000.
      Returns:
        a `ListInventoriesResponse` containing the list of all software inventory metadata.
      Throws:
        `java.lang.Exception`

    - #### describeInventory

          @GET
           @Path(value="{inventoryID}")
          DescribeInventoryResponse describeInventory(@CookieParam(value="sID")
                                                                                         java.lang.String sessionID,
                                                                                         @PathParam(value="inventoryID")
                                                                                         java.lang.Long inventoryID)
                                                                                  throws java.lang.Exception

      Retrieve inventory list metadata.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API.
        `inventoryID` - the inventory list ID.
      Returns:
        a `DescribeInventoryResponse` containing metadata about the inventory list.
      Throws:
        `java.lang.Exception`

    - #### getInventory

          @GET
           @Path(value="{inventoryID}/details")
          GetInventoryResponse getInventory(@CookieParam(value="sID")
                                                                                       java.lang.String sessionID,
                                                                                       @PathParam(value="inventoryID")
                                                                                       java.lang.Long inventoryID,
                                                                                       @QueryParam(value="itemID")
                                                                                       java.lang.Long itemID,
                                                                                       @QueryParam(value="itemIDOp")
                                                                                       java.lang.String itemIDOp,
                                                                                       @QueryParam(value="maxItems")
                                                                                       java.lang.Integer maxItems)
                                                                                throws java.lang.Exception

      Retrieve inventory list details.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API.
        `inventoryID` - the inventory list ID.
        `itemID` - (optional) used to define the starting point for the query. Combine with `itemIDOp` to page through results.
        `itemIDOp` - (optional, required if `itemID` is specified) Currently supported operations include gt(greater than), ge(greater than or equal to), eq(eqaul to), lt(less than), and le(less than or equal to).
        `maxItems` - (optional) the number of items to retrieve. The maximum value for this parameter is controlled by the "Maximum number of items to retrieve from database" setting on the administrator account, which defaults to 5000.
      Returns:
        the detailed inventory listing of all applications detected in the inventory scan.
      Throws:
        `java.lang.Exception`

    - #### deleteInventory

          @DELETE
           @Path(value="{inventoryID}")
          void deleteInventory(@CookieParam(value="sID")
                                                                     java.lang.String sessionID,
                                                                     @PathParam(value="inventoryID")
                                                                     java.lang.Long inventoryID)
                                                              throws java.lang.Exception

      Delete an inventory list.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API.
        `inventoryID` - the inventory list ID.
      Throws:
        `java.lang.Exception`

Copyright © 2017 Trend Micro Inc. All Rights Reserved.